using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.IO;
using System.Diagnostics;
using Infragistics.Win;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private DataTable dt1;

        private void Form1_Load(object sender, System.EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(100, new Type[] { typeof(string) });            
            this.ultraGrid1.DataSource = dt1;

            this.ultraGrid1.CreationFilter = new MulitButtonCreationFilter();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand rootBand = layout.Bands[0];
            UltraGridOverride ov = layout.Override;

            UltraGridColumn column = rootBand.Columns.Add("Buttons");
            ov.DefaultRowHeight = 54;

       }

        private void button1_Click(object sender, EventArgs e)
        {
            
        }

    }   
 
    public class MulitButtonCreationFilter : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            // Do nothing
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            if (parent is CellUIElement)
            {
                UltraGridCell cell = parent.GetContext(typeof(UltraGridCell)) as UltraGridCell;
                if (cell == null)
                {
                    Debug.Fail("Failed to get a cell from a CellUIElement; unexpected");
                    return false;
                }

                if (cell.Column.Key == "Buttons")
                {
                    Rectangle cellRect = parent.RectInsideBorders;

                    int oneThirdCellHeight = cellRect.Height / 3;

                    MyButtonElement buttonElement1 = new MyButtonElement(parent, cell, 1);
                    buttonElement1.Rect = new Rectangle(
                        cellRect.X,
                        cellRect.Y,
                        cellRect.Width,
                        oneThirdCellHeight);                    
                    parent.ChildElements.Add(buttonElement1);

                    MyButtonElement buttonElement2 = new MyButtonElement(parent, cell, 2);
                    buttonElement2.Rect = new Rectangle(
                        cellRect.X,
                        cellRect.Y + oneThirdCellHeight,
                        cellRect.Width,
                        oneThirdCellHeight);
                    parent.ChildElements.Add(buttonElement2);

                    MyButtonElement buttonElement3 = new MyButtonElement(parent, cell, 3);
                    buttonElement3.Rect = new Rectangle(
                        cellRect.X,
                        cellRect.Y + (oneThirdCellHeight * 2),
                        cellRect.Width,
                        oneThirdCellHeight);
                    parent.ChildElements.Add(buttonElement3);

                    buttonElement1.Click += new EventHandler(buttonElement_Click);
                    buttonElement2.Click += new EventHandler(buttonElement_Click);
                    buttonElement3.Click += new EventHandler(buttonElement_Click);

                    return true;
                }
            }

            return false;
        }

        void buttonElement_Click(object sender, EventArgs e)
        {
            MyButtonElement buttonElement = (MyButtonElement)sender;
            StringBuilder sb = new StringBuilder();            
            sb.AppendFormat("Row: {0}", buttonElement.Cell.Row.Index.ToString());
            sb.AppendLine();
            sb.AppendFormat("Button: {0}", buttonElement.Index.ToString());
            MessageBox.Show(sb.ToString(), "Button clicked");
        }

        #endregion
    }

    public class MyButtonElement : ButtonUIElement
    {
        private UltraGridCell cell;
        private int index;
        public event EventHandler Click; 

        public MyButtonElement(UIElement parent, UltraGridCell cell, int index) : base(parent)
        {
            this.cell = cell;
            this.index = index;
        }

        public UltraGridCell Cell
        {
            get { return this.cell; }
        }

        public int Index
        {
            get { return this.index; }
        }

        protected override void OnClick()
        {
            base.OnClick();

            this.Click(this, EventArgs.Empty);
        }
    }

}